
/********************************************************************
* NAME:                                                             *
*                                                                   *
* PURPOSE:                                                          *
*                                                                   *
* GLOBAL VARIABLES:                                                 *
*                                                                   *
* Variable:                                                         *
*                                                                   *
* Type:                                                             *
*                                                                   *
* Description:                                                      *
*                                                                   *
*                                                                   *
* DEVELOPMENT HISTORY:                                              *
*                                                                   *
* Date:                                                             *
*                                                                   *
* Author:                                                           *
*                                                                   *
* Change Id:                                                        *
*                                                                   *
* Release:                                                          *
*                                                                   *
* Description of change:                                            *
*                                                                   *
*********************************************************************/


#ifndef __sysdef_h
#define __sysdef_h

#define SYS_MAX_LOGSTRING_LEN 128
#define SYS_MAX_PATHNAME_LEN 128
#define SYS_MAX_FILENAME_LEN 64
#define SYS_MAX_EXTENSION_LEN 8
#define SYS_GENERAL_HEADER_LEN 128


#define UINT16 unsigned short
#define SINT16 signed short
#define UINT8 unsigned char
#include <stdlib.h>
#define SINT8 signed char
#define UINT32 unsigned long
#define SINT32 signed long
//#define UINT64 unsigned __int64
//#define SINT64 __int64
#define BOOL int
//unsigned char
//#ifndef WIN32
#ifndef TRUE
    #define TRUE 1
#endif
#ifndef FALSE
    #define FALSE 0
#endif
//#endif

typedef enum {
              DEBUG_LEVEL_NONE = 0,
              DEBUG_LEVEL_LOW,
              DEBUG_LEVEL_MEDIUM,
              DEBUG_LEVEL_HIGH,
             } eDEBUG_LEVEL;

#ifdef DEBUG_PRT
  extern eDEBUG_LEVEL debug_level;
  extern char logbuffer[SYS_MAX_LOGSTRING_LEN];

  #define DBGSTR(l,x) if (debug_level>=l) {memset(logbuffer,0,sizeof(logbuffer)); sprintf(logbuffer,x); misc_handlelogstring(FALSE,FALSE);}
  #define DBGSTR1(l,x,p1) if (debug_level>=l) {memset(logbuffer,0,sizeof(logbuffer)); sprintf(logbuffer,x,p1); misc_handlelogstring(FALSE,FALSE);}
  #define DBGSTR2(l,x,p1,p2) if (debug_level>=l) {memset(logbuffer,0,sizeof(logbuffer)); sprintf(logbuffer,x,p1,p2); misc_handlelogstring(FALSE,FALSE);}
  #define DBGSTR3(l,x,p1,p2,p3) if (debug_level>=l) {memset(logbuffer,0,sizeof(logbuffer)); sprintf(logbuffer,x,p1,p2,p3); misc_handlelogstring(FALSE,FALSE);}
  #define DBGSTR4(l,x,p1,p2,p3,p4) if (debug_level>=l) {memset(logbuffer,0,sizeof(logbuffer)); sprintf(logbuffer,x,p1,p2,p3,p4); misc_handlelogstring(FALSE,FALSE);}

  #define _ERROR(x) if (debug_level>=DEBUG_LEVEL_LOW) {memset(logbuffer,0,sizeof(logbuffer)); sprintf(logbuffer,x); misc_handlelogstring(TRUE,TRUE);}
  #define _ERROR1(x,p1) if (debug_level>=DEBUG_LEVEL_LOW) {memset(logbuffer,0,sizeof(logbuffer)); sprintf(logbuffer,x,p1); misc_handlelogstring(TRUE,TRUE);}
  #define _ERROR2(x,p1,p2) if (debug_level>=DEBUG_LEVEL_LOW) {memset(logbuffer,0,sizeof(logbuffer)); sprintf(logbuffer,x,p1,p2); misc_handlelogstring(TRUE,TRUE);}
  #define _ERROR3(x,p1,p2,p3) if (debug_level>=DEBUG_LEVEL_LOW) {memset(logbuffer,0,sizeof(logbuffer)); sprintf(logbuffer,x,p1,p2,p3); misc_handlelogstring(TRUE,TRUE);}
  #define _ERROR4(x,p1,p2,p3,p4) if (debug_level>=DEBUG_LEVEL_LOW) {memset(logbuffer,0,sizeof(logbuffer)); sprintf(logbuffer,x,p1,p2,p3,p4); misc_handlelogstring(TRUE,TRUE);}

  #define INFO(x) if (debug_level>=DEBUG_LEVEL_LOW) {memset(logbuffer,0,sizeof(logbuffer)); sprintf(logbuffer,x); misc_handlelogstring(TRUE,FALSE);}
  #define INFO1(x,p1) if (debug_level>=DEBUG_LEVEL_LOW) {memset(logbuffer,0,sizeof(logbuffer)); sprintf(logbuffer,x,p1); misc_handlelogstring(TRUE,FALSE);}
  #define INFO2(x,p1,p2) if (debug_level>=DEBUG_LEVEL_LOW) {memset(logbuffer,0,sizeof(logbuffer)); sprintf(logbuffer,x,p1,p2); misc_handlelogstring(TRUE,FALSE);}
  #define INFO3(x,p1,p2,p3) if (debug_level>=DEBUG_LEVEL_LOW) {memset(logbuffer,0,sizeof(logbuffer)); sprintf(logbuffer,x,p1,p2,p3); misc_handlelogstring(TRUE,FALSE);}
  #define INFO4(x,p1,p2,p3,p4) if (debug_level>=DEBUG_LEVEL_LOW) {memset(logbuffer,0,sizeof(logbuffer)); sprintf(logbuffer,x,p1,p2,p3,p4); misc_handlelogstring(TRUE,FALSE);}

  #define LDBGSTR(x) DBGSTR(DEBUG_LEVEL_LOW,x)
  #define LDBGSTR1(x,p1) DBGSTR1(DEBUG_LEVEL_LOW,x,p1)
  #define LDBGSTR2(x,p1,p2) DBGSTR2(DEBUG_LEVEL_LOW,x,p1,p2)
  #define LDBGSTR3(x,p1,p2,p3) DBGSTR3(DEBUG_LEVEL_LOW,x,p1,p2,p3)
  #define LDBGSTR4(x,p1,p2,p3,p4) DBGSTR4(DEBUG_LEVEL_LOW,x,p1,p2,p3,p4)

  #define MDBGSTR(x) DBGSTR(DEBUG_LEVEL_MEDIUM,x)
  #define MDBGSTR1(x,p1) DBGSTR1(DEBUG_LEVEL_MEDIUM,x,p1)
  #define MDBGSTR2(x,p1,p2) DBGSTR2(DEBUG_LEVEL_MEDIUM,x,p1,p2)
  #define MDBGSTR3(x,p1,p2,p3) DBGSTR3(DEBUG_LEVEL_MEDIUM,x,p1,p2,p3)
  #define MDBGSTR4(x,p1,p2,p3,p4) DBGSTR4(DEBUG_LEVEL_MEDIUM,x,p1,p2,p3,p4)

  #define HDBGSTR(x) DBGSTR(DEBUG_LEVEL_HIGH,x)
  #define HDBGSTR1(x,p1) DBGSTR1(DEBUG_LEVEL_HIGH,x,p1)
  #define HDBGSTR2(x,p1,p2) DBGSTR2(DEBUG_LEVEL_HIGH,x,p1,p2)
  #define HDBGSTR3(x,p1,p2,p3) DBGSTR3(DEBUG_LEVEL_HIGH,x,p1,p2,p3)
  #define HDBGSTR4(x,p1,p2,p3,p4) DBGSTR4(DEBUG_LEVEL_HIGH,x,p1,p2,p3,p4)
#else
  #define ERROR(x)
  #define ERROR1(x,p1)
  #define ERROR2(x,p1,p2)
  #define ERROR3(x,p1,p2,p3)
  #define ERROR4(x,p1,p2,p3,p4)

  #define INFO(x)
  #define INFO1(x,p1)
  #define INFO2(x,p1,p2)
  #define INFO3(x,p1,p2,p3)
  #define INFO4(x,p1,p2,p3,p4)

  #define LDBGSTR(x)
  #define LDBGSTR1(x,p1)
  #define LDBGSTR2(x,p1,p2)
  #define LDBGSTR3(x,p1,p2,p3)
  #define LDBGSTR4(x,p1,p2,p3,p4)

  #define MDBGSTR(x)
  #define MDBGSTR1(x,p1)
  #define MDBGSTR2(x,p1,p2)
  #define MDBGSTR3(x,p1,p2,p3)
  #define MDBGSTR4(x,p1,p2,p3,p4)

  #define HDBGSTR(x)
  #define HDBGSTR1(x,p1)
  #define HDBGSTR2(x,p1,p2)
  #define HDBGSTR3(x,p1,p2,p3)
  #define HDBGSTR4(x,p1,p2,p3,p4)
#endif


#define MY_LOBYTE(x) (UINT8)((UINT16)x & 0xFF)
#define MY_HIBYTE(x) (UINT8)((UINT16)(x >> 8) & 0xFF)

#define MY_LOWORD(x) (UINT16)((UINT32)x & 0xFFFF)
#define MY_HIWORD(x) (UINT16)((UINT32)(x >> 16) & 0xFFFF)

#ifdef WIN32
#define strncasecmp strnicmp
#define strcasecmp stricmp
#endif

#endif
