/********************************************************************
*                                                                   *
* FILE NAME:                                                        *
*                                                                   *
* PURPOSE:                                                          *
*                                                                   *
* FILE REFERENCES:                                                  *
*                                                                   *
* Name:                                                             *
*                                                                   *
* I/O:                                                              *
*                                                                   *
* Description:                                                      *
*                                                                   *
* EXTERNAL VARIABLES:                                               *
*                                                                   *
* Source:  <      >                                                 *
*                                                                   *
* Name:                                                             *
*                                                                   *
* Type:                                                             *
*                                                                   *
* I/O:                                                              *
*                                                                   *
* Description:                                                      *
*                                                                   *
*                                                                   *
* EXTERNAL REFERENCES:                                              *
*                                                                   *
* Name:                                                             *
*                                                                   *
* Description:                                                      *
*                                                                   *
*                                                                   *
* ABNORMAL TERMINATION CONDITIONS, ERROR AND WARNING MESSAGES:      *
*                                                                   *
* ASSUMPTIONS, CONSTRAINTS, RESTRICTIONS:                           *
*                                                                   *
* NOTES:                                                            *
*                                                                   *
* REQUIREMENTS/FUNCTIONAL SPECIFICATIONS REFERENCES:                *
*                                                                   *
* DEVELOPMENT HISTORY:                                              *
*                                                                   *
* Date:                                                             *
*                                                                   *
* Author:                                                           *
*                                                                   *
* Change Id:                                                        *
*                                                                   *
* Release:                                                          *
*                                                                   *
* Description of change:                                            *
*                                                                   *
********************************************************************/
#include "../include/config.h"

//#include <Windows.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include "../include/sysdef.h"
#include "../include/fls1pub.h"
#include "cmdloc.h"
#include "cmdpub.h"

extern eFLASH_ERROR flash_errno;
static char errbuff[128];
pLogCallout mylog = NULL;

//#include "../include/lib.inc"

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static void cmdline_readarg(char *arg,void *val,BOOL Bnumber)
{
  UINT16 U16start = *((UINT16 *)arg);

  if (Bnumber)
  {
    /* 0x or 0X */
    if (U16start==0x7830 || U16start==0x5830)
      *((long *)val) = misc_hextodword(arg);
    else
      *((long *)val) = atol(arg);
  }
  else
   strcpy((char *)val,arg);
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static BOOL cmdline_analyzearg(char *arg,tCMDLINE_USED_COMMAND **actcmd,tCMDLINE_USED_COMMANDS *usedcommands)
{
  UINT8 i,*U8numcmds,*U8numargs;
  BOOL Bfound;
  char argcmd[CMDLINE_MAX_LONGCMD_LEN];

  if (arg[0]=='-' || arg[0]=='/' || arg[0]=='\\') // it is a command
  {
    strcpy(argcmd,&arg[1]);
    for (i=0;i<(UINT8)strlen(argcmd);i++)
      argcmd[i]=tolower(argcmd[i]);

    for (Bfound = FALSE,i=0;i<U8num_of_knokcmds && !Bfound;i++)
    {
      Bfound = strcmp(knokcmd[i].longcmd_str,argcmd)==0 ||
               strcmp(knokcmd[i].shortcmd_str,argcmd)==0;
      if (Bfound)
      {
        U8numcmds = &usedcommands->U8num_of_commands;

        if (*U8numcmds>=CMDLINE_MAX_COMMANDS)
          return FALSE;

        *actcmd = &usedcommands->command[*U8numcmds];

        strcpy((*actcmd)->longcmd_str,knokcmd[i].longcmd_str);
        (*actcmd)->U16cmdidx=i;
        (*U8numcmds)++;
      }
    }

    if (!Bfound)
      return FALSE;
  }
  else
  {
    if (!(*actcmd)) /* can't start with argument */
      return FALSE;

    U8numargs = &(*actcmd)->U8num_of_args;

    if (*U8numargs>=CMDLINE_MAX_CMD_ARGS)
      return FALSE;

    strcpy((*actcmd)->arg[*U8numargs].value,arg);
    (*U8numargs)++;
  }

  return TRUE;
}

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static BOOL cmdline_getnextnumberfromarg(char *currargptr,char **nextargptr,UINT32 *U32num,BOOL *Blast)
{
  char tmpnum[CMDLINE_MAX_ARGLEN];
  UINT8 i=0;
  BOOL Bfinished,Bhexenabled;
  UINT16 U16start = *((UINT16 *)currargptr);
  char chr;

  memset(tmpnum,0,sizeof(tmpnum));

  /* arg starts with 0x or 0X */
  Bhexenabled = (U16start==0x7830 || U16start==0x5830);
  if (Bhexenabled)
    currargptr+=2; /* skip "header" */

  *Blast = FALSE;
  *U32num = 0;
  *nextargptr = NULL;

  for (Bfinished = FALSE;!Bfinished;currargptr++)
  {
    chr = toupper(*currargptr);

    if (!Bhexenabled)
      Bfinished = (chr<'0' || chr>'9');
    else
      {
       Bfinished = !(
                     (chr>='0' && chr<='9') ||
                     (chr>='A' && chr<='F')
                    );
      }

    /* EOF? */
    *Blast = chr=='\0';
    Bfinished = Bfinished || *Blast;

    if (!Bfinished)
      tmpnum[i++]=chr;
  }

  *nextargptr = currargptr-1;

  if (strlen(tmpnum)==0)
  {
    *Blast = TRUE;
    return FALSE;
  }

  /* 0x or 0X */
  if (Bhexenabled)
    *U32num = misc_hextodword(tmpnum);
  else
    *U32num = atol(tmpnum);

  return TRUE;
}

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static BOOL cmdline_convertnumarg(char *arg,tCMDLINE_RUNTIME_COMMAND *runtimecmd)
{
  char *nextargptr,*currargptr = arg;
  UINT32 U32num,U32end;
  UINT32 i = runtimecmd->U8num_of_numargs,j;
  BOOL Blast = FALSE,Bfinished;

  while (!Blast)
  {
    if (!cmdline_getnextnumberfromarg(currargptr,&nextargptr,&U32num,&Blast))
    {
       return FALSE;
    }

    if (i>=CMDLINE_MAX_EXPANDED_NUMBERS)
    {
       return FALSE;
    }

    runtimecmd->U32numarg[i] = U32num;
    i++;

    currargptr = nextargptr;
    if (*currargptr==',')
      currargptr++;
    else if (*currargptr=='.' && *(currargptr+1)=='.')
    {
      if (!cmdline_getnextnumberfromarg(currargptr+2,&nextargptr,&U32end,&Blast))
      {
         return FALSE;
      }

      for (Bfinished=FALSE,j=U32num+1;!Bfinished && j<=U32end;i++,j++)
      {
        Bfinished = i>CMDLINE_MAX_EXPANDED_NUMBERS;
        if (!Bfinished)
          runtimecmd->U32numarg[i] = j;
      }
      currargptr = nextargptr;
      if (*currargptr==',')
        currargptr++;
    }
  }

  runtimecmd->U8num_of_numargs = (UINT8)i;

  return TRUE;
}

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static BOOL cmdline_convertarg(char *arg,eCMDLINE_COMMAND_ARGUMENT_TYPE argtype,tCMDLINE_RUNTIME_COMMAND *runtimecmd)
{
  char *posstart,*posend;
  UINT16 U16strlen;
  UINT32 i = runtimecmd->U8num_of_strargs;

  switch (argtype)
  {
       case FCAT_STRING:
         posstart = strchr(arg,CMDLINE_STRING_SEP);
         if (posstart==NULL)
           posstart = arg;
         else
           posstart++; /* skip start */

         posend = strchr(posstart,CMDLINE_STRING_SEP);
         if (posend==NULL)
           U16strlen = strlen(arg);
         else
           U16strlen = posend - posstart;

         if (i>=CMDLINE_MAX_STRINGS)
         {
           return FALSE;
         }

         strncpy(runtimecmd->stringarg[i].value,posstart,U16strlen);
         runtimecmd->U8num_of_strargs++;
         return TRUE;

       case FCAT_NUMBER:
         if (!cmdline_convertnumarg(arg,runtimecmd))
         {
            return FALSE;
         }
         return TRUE;

       default:
       case FCAT_NONE:
         break;
  }

  return TRUE;
}

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static BOOL cmdline_convertcommandargs(const tCMDLINE_CMDBLOCK *cmd,tCMDLINE_USED_COMMAND *usedcommand,tCMDLINE_RUNTIME_COMMANDS *runtimecommands)
{
  UINT8 i;
  UINT8 *U8numofcommands = &runtimecommands->U8num_of_commands;
  tCMDLINE_RUNTIME_COMMAND *runtimecmd;

  if (*U8numofcommands>CMDLINE_MAX_COMMANDS)
  {
    return FALSE;
  }

  runtimecmd = &runtimecommands->command[*U8numofcommands];
  runtimecmd->cmd = cmd->cmd;
  runtimecmd->Bneedflasher = cmd->Bneedflasher;
  runtimecmd->Bneedmbus = cmd->Bneedmbus;
  runtimecmd->Bneedfchk = cmd->Bneedfchk;
  runtimecmd->Bneedinfo = cmd->Bneedinfo;
  strcpy(runtimecmd->longcmd_str,cmd->longcmd_str);

  (*U8numofcommands)++;

  if (cmd->U8num_of_args==0) /* no argument for the given command */
  {
    if (usedcommand->U8num_of_args>0)
    {
      return FALSE;
    }

    return TRUE;
  }

  if (!cmd->Boptionalargs)
  {
    if (cmd->U8num_of_args!=usedcommand->U8num_of_args) /* less arguments */
    {
      return FALSE;
    }
  }
  else /* we have optional arguments */
  {
    if (usedcommand->U8num_of_args>cmd->U8num_of_args) /* more arguments, less is accepted */
    {
      return FALSE;
    }
  }

  for (i=0;i<usedcommand->U8num_of_args;i++)
  {
    if (!cmdline_convertarg(usedcommand->arg[i].value,cmd->argtype[i],runtimecmd))
    {
       return FALSE;
    }
  }

  return TRUE;
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static BOOL cmdline_analyzeargs(int argc,char *argv[],tCMDLINE_USED_COMMANDS *usedcommands,tCMDLINE_RUNTIME_COMMANDS *runtimecommands,char *MSSW,BOOL *Brunanalyze)
{
  UINT8 i;
  const tCMDLINE_CMDBLOCK *cmd;
  tCMDLINE_USED_COMMAND *actcmd;

  *Brunanalyze = FALSE;

  memset(usedcommands,0,sizeof(*usedcommands));
  memset(runtimecommands,0,sizeof(*runtimecommands));

  if (argc<2)
  {
    return FALSE;
  }

  /* the first is always the phone model */
  cmdline_readarg(argv[1],MSSW,FALSE);

  actcmd = NULL;
  for (i=2;i<argc;i++)
  {
    if (!cmdline_analyzearg(argv[i],&actcmd,usedcommands))
      return FALSE;
  }

  /* We have commands and arguments */
  for (i=0;i<usedcommands->U8num_of_commands;i++)
  {
     actcmd = &usedcommands->command[i];
     cmd = &knokcmd[actcmd->U16cmdidx];
     if (cmd->Bneedsanalyze)
       *Brunanalyze = TRUE;

     if (!cmdline_convertcommandargs(cmd,actcmd,runtimecommands)) /* bad arg */
     {
       return FALSE;
     }
  }

  return TRUE;
}

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static void cmd_help(void)
{
  UINT8 i;

  INFOSTR("Usage:");
  INFOSTR(" knok NSE-1 cmd1 arg1 cmd2 arg2 ...");
  for (i=0;i<U8num_of_knokcmds;i++)
    INFOSTR3("- %s(%s) : %s",knokcmd[i].longcmd_str,knokcmd[i].shortcmd_str,knokcmd[i].help);
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static void cmd_welcome(void)
{
  INFOSTR2("kNok - Engine build %d, Frontend build %d",ENGINE_BUILD,CMDLINE_BUILD);
  INFOSTR("Thanks goes out for the following:");
  INFOSTR("Dejan, Kodo, Viper, Jozso (for hardware and cable support");
  INFOSTR("and of course beta testing), Bph&Co, IceDragon, Steina,");
  INFOSTR("Epilog, Invisible, Jethro, H-tom, AlAraf, Lead");
  INFOSTR("and all the others who supports knok...");
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

BOOL cmd_loadconfig(char *configcfg,char *bloaderpath,char *configpath,char *modelslist,char *devlist, char *flashidlist, char *algocodelist, char *tiaext,UINT32 *pU32comdelay)
{
  FILE *rfile;
  SINT16 numinputfields;

  rfile = fopen(configcfg,"rt");
  if (!rfile)
  {
    return FALSE;
  }

  numinputfields = fscanf(rfile,"%s\n%s\n%s\n%s\n%s\n%s\n%s\n%d",bloaderpath,configpath,modelslist,devlist,flashidlist,algocodelist,tiaext,pU32comdelay);
  fclose(rfile);

  if (numinputfields!=8)
  {
    return FALSE;
  }

  return TRUE;
}

/** handle -uploadcode command **/
static BOOL cmd_uploadcode(char *NMP, char *path) {

  UINT8 U8fval1,U8fval2;
  char bloadername[SYS_MAX_FILENAME_LEN];
  tFLS1_CONFIGURATIONRESPONSE_DCT3 configuration;
  tFLS1_DELAYBLOCK delayblock;
  FILE *rfile;
  size_t codesize;
  UINT8 *code;
  //UINT8 testcode[] = {0x00, 0x00, 0x00, 0x05, 0xE7, 0xFE}; /* jump self */
  UINT8 *d;

  
	FLS1_GetFlashParameters(NMP, &U8fval1, &U8fval2, bloadername);
	//printf("%s\n",bloadername);
	
	if (!FLS1_SendBootstrapDCT3(bloadername,U8fval1,50,&configuration)) {
	    printf("Sending bootstrap failed!\n");
            return FALSE;
	}
	printf("Bootstrap sent ASIC ID = %02x.\n",configuration.U8asicid);
	d = &configuration.flashid[0];
	printf("Bootstrap sent FLASHID = %02x%02x%02x%02x.\n",d[0],d[1],d[2],d[3]);
	FLS1_GetDefaultTimes(&delayblock);
	printf("Loading code %s from disk.\n", path);
	/*
	typedef BOOL (*pSendCodeDCT3)(UINT8 *code,
				size_t codesize,
				tFLS1_DELAYBLOCK *delayblock);
	*/
	/*
	load code from disk, todo 
	*/
	
	rfile = fopen(path,"rb");
	if (!rfile)
	{
		printf("Could not open code file\n");
		return FALSE;
	}
	fseek(rfile,0,SEEK_END);
	codesize = ftell(rfile);
	fseek(rfile,0,SEEK_SET);
	code = malloc(codesize);
	fread(code, 1, codesize, rfile);
	fclose(rfile);

	printf("Loaded %i bytes.\n",codesize);
	
	
	if(!FLS1_SendCodeDCT3(code, codesize, &delayblock)) {
	    printf("Sending code failed!\n");
            return FALSE;
	}
	/*
	if(!FLS1SendCodeDCT3(testcode, sizeof(testcode), &delayblock)) {
	    printf("Sending code failed!\n");
            return FALSE;
	}
	*/
	
	printf("Code sent.\n");
	free(code);
}

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static BOOL cmd_handlecommands(char *MSSW,tCMDLINE_RUNTIME_COMMANDS *runtimecommands,BOOL Bneedinfo,BOOL Banalyze, BOOL Bneedflasher, BOOL Bneedmbus, BOOL Bneedfchk, UINT32 *pU32fchk)
{
  /* don't try to place that onto stack */
  static tFLASH_PHONE_INFO phone_info;

  UINT8 i;
  tCMDLINE_RUNTIME_COMMAND *actcmd;
  char phonefile[SYS_MAX_PATHNAME_LEN], lgpack[4];
  char tmpfile[SYS_MAX_PATHNAME_LEN],tmpfile2[SYS_MAX_PATHNAME_LEN];
  BOOL Bconfirm = FALSE;
  BOOL Bbinary;
  BOOL Bchanged;
  BOOL Bnoerase = FALSE;

  if (pU32fchk)
  {
    *pU32fchk = 0;
  }

  memset(&phone_info,0,sizeof(phone_info));

  if (Bneedinfo)
  {
    if (!FLS1_GetPhoneInfo(&phone_info,MSSW,Banalyze,Bneedflasher,Bneedmbus,Bneedfchk))
    {
      INFOSTR("CMD_handlecommands : cannot analyze phone");
    }
  }

  sprintf(phonefile,"%s (%s) V%02d.%02d",phone_info.MSSW, phone_info.NMP, MY_HIBYTE(phone_info.S32MCUversion),MY_LOBYTE(phone_info.S32MCUversion));

  strcpy(tmpfile,phonefile);
  if (Banalyze && Bneedflasher) /* in only this case we have the language pack */
  {
    sprintf(lgpack," %c ",phone_info.Clanguage_pack);
    strcat(tmpfile,lgpack);
  }

  for (i=0;i<runtimecommands->U8num_of_commands;i++)
  {
     actcmd = &runtimecommands->command[i];
     switch (actcmd->cmd)
     {
            default:
            case FC_NONE:
                    break;

            case FC_NO_ERASE:
                    FLS1_SetSkipErase(TRUE);
                    Bnoerase = TRUE;
                    break;

            case FC_CONFIRM:
                    Bconfirm = TRUE;
                    break;

            case FC_ERASE:
                    if (!Bconfirm)
                    {
                      ERRORSTR("CMD_handlecommands : erase was not '-confirm' -ed");
                      break;
                    }

                    if (!FLS1_EraseLarge(actcmd->U32numarg[0],actcmd->U32numarg[1]))
                      return FALSE;
                    break;

            case FC_ERASEALL:
                    if (!Bconfirm)
                    {
                      ERRORSTR("CMD_handlecommands : erase was not '-confirm' -ed");
                      break;
                    }

                    if (!FLS1_EraseAll())
                      return FALSE;
                    break;

            case FC_READ:
            case FC_RAW_READ:
                    if (!FLS1_ReadLarge(actcmd->U32numarg[0],actcmd->U32numarg[1],tmpfile,actcmd->cmd==FC_RAW_READ))
                      return FALSE;
                    break;

            case FC_READ_ALL:
            case FC_RAW_READ_ALL:
                    Bbinary = actcmd->cmd==FC_RAW_READ_ALL;
                    if (!FLS1_SaveBlocks(&phone_info.mcu_blocks,tmpfile,"MCU %02d-%02d",actcmd->U8num_of_numargs,&actcmd->U32numarg[0],Bbinary))
                      return FALSE;

                    if (!FLS1_SaveBlock(&phone_info.ppm_header_block,tmpfile,"PPM header",Bbinary))
                      return FALSE;

                    if (!FLS1_SaveBlocks(&phone_info.ppm_blocks,tmpfile,"PPM %02d-%02d",actcmd->U8num_of_numargs,&actcmd->U32numarg[0],Bbinary))
                      return FALSE;

                    if (!FLS1_SaveBlocks(&phone_info.pmm_blocks,tmpfile,"PMM %02d-%02d",actcmd->U8num_of_numargs,&actcmd->U32numarg[0],Bbinary))
                      return FALSE;

                    if (!FLS1_SaveBlocks(&phone_info.eeprom_blocks,tmpfile,"EEPROM %02d-%02d",actcmd->U8num_of_numargs,&actcmd->U32numarg[0],Bbinary))
                      return FALSE;
                    break;

            case FC_READ_MCU:
            case FC_RAW_READ_MCU:
                    Bbinary = actcmd->cmd==FC_RAW_READ_MCU;
                    if (!FLS1_SaveBlocks(&phone_info.mcu_blocks,tmpfile,"MCU %02d-%02d",actcmd->U8num_of_numargs,&actcmd->U32numarg[0],Bbinary))
                      return FALSE;
                    break;

            case FC_READ_PPM:
            case FC_RAW_READ_PPM:
                    Bbinary = actcmd->cmd==FC_RAW_READ_PPM;
                    if (!FLS1_SaveBlocks(&phone_info.ppm_blocks,tmpfile,"PPM %02d-%02d",actcmd->U8num_of_numargs,&actcmd->U32numarg[0],Bbinary))
                      return FALSE;
                    break;

            case FC_READ_PMM:
            case FC_RAW_READ_PMM:
                    Bbinary = actcmd->cmd==FC_RAW_READ_PMM;
                    if (!FLS1_SaveBlocks(&phone_info.pmm_blocks,tmpfile,"PMM %02d-%02d",actcmd->U8num_of_numargs,&actcmd->U32numarg[0],Bbinary))
                      return FALSE;
                    break;

            case FC_READ_EEPROM:
            case FC_RAW_READ_EEPROM:
                    Bbinary = actcmd->cmd==FC_RAW_READ_EEPROM;
                    if (!FLS1_SaveBlocks(&phone_info.eeprom_blocks,tmpfile,"EEPROM %02d-%02d",actcmd->U8num_of_numargs,&actcmd->U32numarg[0],Bbinary))
                      return FALSE;
                    break;

            case FC_WRITE:
            case FC_RAW_WRITE:
                    if (!Bnoerase && !Bconfirm)
                    {
                      ERRORSTR("CMD_handlecommands : erase was not '-confirm' -ed");
                      break;
                    }

                    Bbinary = actcmd->cmd==FC_RAW_WRITE;

                    if (Bbinary)
                    {
                      if (!FLS1_WriteLarge(FLS_EXTENSION_ID,actcmd->stringarg[0].value,actcmd->U32numarg[1],actcmd->U32numarg[2],actcmd->U32numarg[0],Bbinary))
                        return FALSE;
                    }
                    else
                    {
                      if (!FLS1_WriteLarge(KNK_EXTENSION_ID,actcmd->stringarg[0].value,actcmd->U32numarg[0],actcmd->U32numarg[1],0,Bbinary))
                        return FALSE;
                    }
                    break;

            case FC_WRITE_PHONEINFO:
            case FC_WRITE_PHONEINFO_AND_CHECKSUM:
                    strcpy(tmpfile2,tmpfile);
                    strcat(tmpfile2,"phone info." FLASH_LOG_EXTENSION);

                    if (!FLS1_SavePhoneInfo(&phone_info,tmpfile2,Bneedfchk))
                      return FALSE;

                    if (Bneedfchk && pU32fchk && phone_info.U32fchk!=0)
                    {
                      *pU32fchk = phone_info.U32fchk;
                    }
                    break;
	    /*
            case FC_WRITE_SECURITY_PHONEINFO:
                    strcpy(tmpfile2,tmpfile);
                    strcat(tmpfile2," security phone info." FLASH_LOG_EXTENSION);

                    if (!FLS1_SaveSecurityPhoneInfo(tmpfile2))
                      return FALSE;
                    break;
	    */
            case FC_READ_FULLFLASH:
            case FC_RAW_READ_FULLFLASH:
                    if (!FLS1_ReadFullFlash(tmpfile,actcmd->cmd==FC_RAW_READ_FULLFLASH))
                      return FALSE;
                    break;

            case FC_CHECK_CHECKSUMS:
            case FC_FIX_CHECKSUMS:
                    if (!FLS1_CheckChecksums(&phone_info,actcmd->cmd==FC_FIX_CHECKSUMS))
                      return FALSE;

                    if (pU32fchk && phone_info.U32fchk!=0)
                    {
                      *pU32fchk = phone_info.U32fchk;
                    }
                    break;

            case FC_CHECK_IMEI:
            case FC_FIX_IMEI:
                    if (!FLS1_CheckIMEI(&phone_info,actcmd->cmd==FC_FIX_IMEI,&Bchanged))
                      return FALSE;

                    if (Bchanged)
                    {
                      if (!FLS1_CheckChecksums(&phone_info,TRUE))
                        return FALSE;
                    }
                    break;

            case FC_CHECK_SECCODE:
            case FC_FIX_SECCODE:
                    if (!FLS1_CheckSecurityCode(&phone_info,actcmd->cmd==FC_FIX_SECCODE,&Bchanged))
                      return FALSE;

                    if (Bchanged)
                    {
                      if (!FLS1_CheckChecksums(&phone_info,TRUE))
                        return FALSE;
                    }

                    break;

            case FC_CLEAR_SECCODE_COUNTER:
                    if (!FLS1_ClearSecurityCodeCounter(&phone_info,&Bchanged))
                      return FALSE;

                    if (Bchanged)
                    {
                      if (!FLS1_CheckChecksums(&phone_info,TRUE))
                        return FALSE;
                    }
                    break;
/*
            case FC_RESETSETTINGS:
                    if (!FLS1_ResetSettings(actcmd->U32numarg[0]))
                      return FALSE; 
                    break;
*/
/*
            case FC_RESETPHONE:
                    if (!FLS1_ResetPhone())
                      return FALSE; 
                    break;

            case FC_SETSIMLOCK:
                    if (!FLS1_SetSimlock(actcmd->U32numarg[0],actcmd->stringarg[0].value,actcmd->U32numarg[1]))
                      return FALSE; 
                    break;
*/
            case FC_CONVERTTOKNK:
                    if (!FLS1_ConvertToKNK(actcmd->stringarg[0].value,actcmd->U32numarg[0]))
                      return FALSE;
                    break;
/*
            case FC_SETCONTRAST:
                    if (!FLS1_SetContrast(actcmd->U32numarg[0]))
                      return FALSE;
                    break;
*/
/*
            case FC_SET_FAID:
                    if (!FLS1_SetFAID(actcmd->U32numarg[0]))
                      return FALSE;
                    break;
*/
            case FC_CONVERTWTTOFLS:
                    if (!FLS1_ConvertWTFilesToFLSKNK(actcmd->stringarg[0].value,actcmd->stringarg[1].value, FALSE))
                      return FALSE;
                    break;

            case FC_CONVERTWTTOKNK:
                    if (!FLS1_ConvertWTFilesToFLSKNK(actcmd->stringarg[0].value,actcmd->stringarg[1].value, TRUE))
                      return FALSE;
                    break;
/*
            case FC_RESETSPLOCK:
                    if (!FLS1_ResetSPlock())
                      return FALSE;
                    break;

            case FC_SETIMEI:
                    if (!FLS1_SetIMEI(actcmd->stringarg[0].value))
                      return FALSE;
                    break;
*/
	    case FC_UPLOADCODE:
		    return cmd_uploadcode(MSSW, actcmd->stringarg[0].value);
		    
     }
  }

  return TRUE;
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static BOOL cmd_handleprecommands(tCMDLINE_RUNTIME_COMMANDS *runtimecommands,UINT8 *numcommands, eREDIRECTION_TYPE *redirection, BOOL *Bneedflasher, BOOL *Bneedmbus, BOOL *Bneedfchk, BOOL *Bneedinfo, char *logfilename, UINT8 *pU8lpt, UINT8 *pU8com, eDEBUG_LEVEL *debug_level,char *emulatefilename, BOOL *Bbinaryemulate, BOOL *Bsafeflashing)
{
  UINT8 i;
  tCMDLINE_RUNTIME_COMMAND *actcmd;

  *redirection = REDIRECTION_TYPE_NONE;
  *logfilename = 0;
  *pU8lpt = 1;
  *pU8com = 1;
  *numcommands = 0;
  *Bneedflasher = FALSE;
  *Bneedmbus = FALSE;
  *Bneedfchk = FALSE;
  *Bneedinfo = FALSE;
  *emulatefilename = 0;
  *Bbinaryemulate = FALSE;
  *Bsafeflashing = FALSE;

  for (i=0;i<runtimecommands->U8num_of_commands;i++)
   {
     actcmd = &runtimecommands->command[i];

     if (actcmd->Bneedfchk)
       *Bneedfchk = TRUE;

     if (actcmd->Bneedflasher)
       *Bneedflasher = TRUE;

     if (actcmd->Bneedmbus)
       *Bneedmbus = TRUE;

     if (actcmd->Bneedinfo)
       *Bneedinfo = TRUE;

     switch (actcmd->cmd)
      {
         default:
             (*numcommands)++;
             break;

         case FC_NONE:
             break;

         case FC_SET_DEBUG_LEVEL:
             *debug_level = actcmd->U32numarg[0];
             actcmd->cmd = FC_NONE; /* executed command */
             break;

         case FC_SET_REDIRECTION:
             *redirection = actcmd->U32numarg[0];
             strcpy(logfilename,FLASH_LOG_FILE);
             actcmd->cmd = FC_NONE; /* executed command */
             break;

         case FC_LPT:
             *pU8lpt = actcmd->U32numarg[0];
             actcmd->cmd = FC_NONE; /* executed command */
             break;

         case FC_COM:
             *pU8com = actcmd->U32numarg[0];
             actcmd->cmd = FC_NONE; /* executed command */
             break;

         case FC_EMULATE:
         case FC_RAW_EMULATE:
             strcpy(emulatefilename,actcmd->stringarg[0].value);
             *Bbinaryemulate = actcmd->cmd==FC_RAW_EMULATE;
             actcmd->cmd = FC_NONE; /* executed command */
             break;

         case FC_SAFEFLASHING:
             *Bsafeflashing = TRUE;
             actcmd->cmd = FC_NONE; /* executed command */
             break;

      }
   }

  return TRUE;
}
void cmd_mylog(char *logstr,BOOL Biserror,BOOL Bshowaserror)
{
  printf("%s\n",logstr);
  if (Biserror && Bshowaserror)
    printf("ERRNO : %08X\n",FLS1_GetErrno());
}



/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

int cmd_main(int argc,char *argv[],pLogCallout logcallout,pGaugeInit gaugeinit,pGaugeDone gaugedone,pGaugeUpdate gaugeupdate,UINT32 *pU32fchk)
{
  /* Linux */
#ifndef WIN32
  ioperm(0x378, 0x8, 1);
#endif
  
  
  char configpath[SYS_MAX_PATHNAME_LEN],bloaderpath[SYS_MAX_PATHNAME_LEN];
  char emulatefilename[SYS_MAX_FILENAME_LEN], modelslist[SYS_MAX_FILENAME_LEN];
  char algocodelist[SYS_MAX_FILENAME_LEN],flashidlist[SYS_MAX_FILENAME_LEN],devlist[SYS_MAX_FILENAME_LEN],logfilename[SYS_MAX_FILENAME_LEN];
  char bloadername[SYS_MAX_FILENAME_LEN];
  UINT8 U8fval1,U8fval2;
  char tiaext[SYS_MAX_EXTENSION_LEN];

  UINT8 U8lpt,U8com;
  UINT32 U32comdelay,U32fchk;
  UINT8 U8numcommands;
  BOOL Bneedfchk = FALSE, Bneedflasher = FALSE, Bneedmbus = FALSE, Bsafeflashing = FALSE;
  BOOL Bbinaryemulate;
  eREDIRECTION_TYPE redirectiontype;

  char MSSW[8],NMP[8];
  tCMDLINE_USED_COMMANDS usedcommands;
  tCMDLINE_RUNTIME_COMMANDS runtimecommands;
  BOOL Banalyze = FALSE,Bneedinfo = FALSE;
  eDEBUG_LEVEL debug_level = DEBUG_LEVEL_HIGH;

  mylog = logcallout==NULL ? cmd_mylog : logcallout;

  cmd_welcome();

  if (!cmdline_analyzeargs(argc,argv,&usedcommands,&runtimecommands,MSSW,&Banalyze))
  {
    cmd_help();
    return FALSE;
  }
  /*
  if (!InitializeLibrary("knokdll.dll"))
  {
    
    ERRORSTR("Cannot initialize library");
    
    if(lib) FreeLibrary(lib);
    return FALSE;
  }
  */
  
  if (!cmd_loadconfig(CMDLINE_CONFIG_FILE,bloaderpath,configpath,modelslist,devlist,flashidlist,algocodelist,tiaext,&U32comdelay))
  {
    ERRORSTR("Cannot load configuration");
    FLS1_Terminate();
    return FALSE;
  }
  
  if (!cmd_handleprecommands(&runtimecommands,&U8numcommands, &redirectiontype, &Bneedflasher, &Bneedmbus, &Bneedfchk, &Bneedinfo, logfilename, &U8lpt, &U8com, &debug_level, emulatefilename, &Bbinaryemulate, &Bsafeflashing))
  {
    FLS1_Terminate();
    return FALSE;
  }
  
  if (U8numcommands==0)
  {
    cmd_help();
    FLS1_Terminate();
    return FALSE;
  }
  
  if (!FLS1_Initialize(debug_level, gaugeinit, gaugedone, gaugeupdate, mylog, redirectiontype, logfilename, FLASH_DELAY_TYPE_RDTSC, 0, U8lpt, U8com, U32comdelay, Bsafeflashing))
  {
    ERRORSTR("Cannot initialize device");
    FLS1_Terminate();
    return FALSE;
  }
  

  FLS1_SetDirectory(FLASH_DIRECTORY_LOADER,bloaderpath);
  FLS1_SetDirectory(FLASH_DIRECTORY_CFG,configpath);
  if (Bneedmbus && strlen(emulatefilename)>0)
  {
    INFOSTR("Emulation cannot be used together with MBUS commands - disabling it");
    emulatefilename[0] = 0;
  }
  
  FLS1_SetEmulation(emulatefilename, Bbinaryemulate);
  FLS1_SetFlashIDList(flashidlist);
  FLS1_SetAlgoCodeList(algocodelist);
  FLS1_SetAlgoCodeExtension(tiaext);
  FLS1_SetAliasIDList(devlist);
  FLS1_SetModelsList(modelslist);
  
  if (Bneedflasher)
  {
    if (!FLS1_PreparePhone(MSSW, 50))
    {
      ERRORSTR("Cannot prepare phone");
      FLS1_Terminate();
      return FALSE;
    }
  }
  else
  {
    if (!FLS1_GetFlashParameters(MSSW, &U8fval1, &U8fval2, bloadername))
    {
      ERRORSTR("Cannot find model");
      FLS1_Terminate();
      return FALSE;
    }
  }

  if (!pU32fchk)
  {
    pU32fchk = &U32fchk;
  }

  if (!cmd_handlecommands(MSSW,&runtimecommands,Bneedinfo,Banalyze,Bneedflasher,Bneedmbus,Bneedfchk,pU32fchk))
  {
    FLS1_Terminate();
    return FALSE;
  }

  if (Bneedflasher)
  {
    if (!FLS1_MCURestart())
    {
      ERRORSTR("Cannot restart MCU");
      FLS1_Terminate();
      return FALSE;
    }
  }

  FLS1_Terminate();

  if (*pU32fchk!=0)
  {
    INFOSTR1("Calculated flash checksum is %08X",*pU32fchk);
  }

  INFOSTR("O.K.");
  return TRUE;
}

