/********************************************************************
*                                                                   *
* FILE NAME:                                                        *
*                                                                   *
* PURPOSE:                                                          *
*                                                                   *
* FILE REFERENCES:                                                  *
*                                                                   *
* Name:                                                             *
*                                                                   *
* I/O:                                                              *
*                                                                   *
* Description:                                                      *
*                                                                   *
* EXTERNAL VARIABLES:                                               *
*                                                                   *
* Source:  <      >                                                 *
*                                                                   *
* Name:                                                             *
*                                                                   *
* Type:                                                             *
*                                                                   *
* I/O:                                                              *
*                                                                   *
* Description:                                                      *
*                                                                   *
*                                                                   *
* EXTERNAL REFERENCES:                                              *
*                                                                   *
* Name:                                                             *
*                                                                   *
* Description:                                                      *
*                                                                   *
*                                                                   *
* ABNORMAL TERMINATION CONDITIONS, ERROR AND WARNING MESSAGES:      *
*                                                                   *
* ASSUMPTIONS, CONSTRAINTS, RESTRICTIONS:                           *
*                                                                   *
* NOTES:                                                            *
*                                                                   *
* REQUIREMENTS/FUNCTIONAL SPECIFICATIONS REFERENCES:                *
*                                                                   *
* DEVELOPMENT HISTORY:                                              *
*                                                                   *
* Date:                                                             *
*                                                                   *
* Author:                                                           *
*                                                                   *
* Change Id:                                                        *
*                                                                   *
* Release:                                                          *
*                                                                   *
* Description of change:                                            *
*                                                                   *
********************************************************************/
#include "../include/config.h"

#include <stdio.h>
#include <string.h>
#include "../include/sysdef.h"
#include "../include/fls1pub.h"	// sadly delayblock must be here
#include "miscpub.h"
#include "fle5loc.h"
#include "fle5pub.h"

static void FLE5_DirectReadByteBlock(UINT16 U16baseport,
				     UINT8 * pAU8buffer, UINT32 U32size,
				     UINT32 U32delay);
static void FLE5_DirectWriteByteBlock(UINT16 U16baseport,
				      UINT8 * pAU8buffer, UINT32 U32size,
				      UINT32 U32delay);
static BOOL FLE5_FuncSendToPhone(UINT16 U16baseport, UINT8 * pAU8buffer,
				 UINT32 U32size, UINT32 U32cmd,
				 tFLS1_DELAYBLOCK * pdelayblock);
static BOOL FLE5_TickDirectWaitForEdge(UINT16 U16baseport, BOOL Bishigh,
				       UINT32 U32retrycount);
static UINT8 FLE5_DirectWriteBit(UINT16 U16baseport, UINT8 * U8baseportval,
				 UINT8 U8high, BOOL Bscllow,
				 UINT32 U32delay6, BOOL Bextradelay,
				 UINT32 U32delay5);
static UINT8 FLE5_DirectReadByte(UINT16 U16baseport, UINT8 * U8baseportval,
				 UINT32 U32delay6, BOOL Bextradelay,
				 UINT32 U32delay5);

static pFLE5WaitForEdge FLE5_DirectWaitForEdge =
    FLE5_TickDirectWaitForEdge;

extern eFLASH_ERROR flash_errno;
//extern UINT32 U32microsec_count;
//extern pDelayFunc misc_delay;

/*
static tFLS1_DELAYBLOCK defaultdelayblock =
    { 1, 50, 50, 10000, 2 * 5, 8 * 5, 2 * 15, 2 * 10, 2 * 10 };
*/

static tFLS1_DELAYBLOCK defaultdelayblock =
    { 1, 50, 50, 10000, 1 * 5, 4 * 5, 2 * 15, 2 * 10, 2 * 10 };


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static BOOL FLE5_DirectInitialiseBootstrapDCT4(UINT16 U16baseport,
					       UINT8 * pAU8buffer,
					       UINT16 U16size,
					       UINT32 * pU32mcuresponse)
{
	UINT8 U8testmodecmd = FLE5_INITTESTMODE_DCT4;
	UINT8 U8executecmd = FLE5_EXECUTECMD;
	UINT16 U16resetcode = 0xFFFF;
	UINT8 U8hisize = MY_HIBYTE(U16size);
	UINT8 U8losize = MY_LOBYTE(U16size);
	UINT8 U8baseportval;

	LDBGSTR
	    ("FLE5_DirectInitialiseBootstrapDCT4 : Press power on (if needed)");

	U8baseportval = misc_inport(U16baseport, 0);
	SCLHIGH(U8baseportval);
	misc_outport(U16baseport, 0, U8baseportval);

	XXXHIGH(U8baseportval);
	misc_outport(U16baseport, 0, U8baseportval);

	misc_delay(defaultdelayblock.U32delay9);

	SCLHIGH(U8baseportval);
	misc_outport(U16baseport, 0, U8baseportval);

	misc_delay(2 * defaultdelayblock.U32delay9);

	FLE5_DirectWriteByteBlock(U16baseport, &U8testmodecmd,
				  sizeof(U8testmodecmd),
				  defaultdelayblock.U32delay5);
	misc_delay(defaultdelayblock.U32delay9);

	SCLLOW(U8baseportval);
	SDAHIGH(U8baseportval);
	misc_outport(U16baseport, 0, U8baseportval);
	misc_delay(4 * defaultdelayblock.U32delay9);

	XXXLOW(U8baseportval);
	misc_outport(U16baseport, 0, U8baseportval);
	misc_delay(defaultdelayblock.U32delay9);

#ifdef USE_BTEMP
	BTEMPHIGH(U8baseportval);
	misc_outport(U16baseport, 0, U8baseportval);
	misc_delay(defaultdelayblock.U32delay9);
#endif

	if (!FLE5_DirectWaitForEdge
	    (U16baseport, TRUE, defaultdelayblock.U32delay7)) {
		flash_errno = FE_PHONE_NOT_RESPOND_9;
		return FALSE;
	}

	if (!FLE5_DirectWaitForEdge
	    (U16baseport, FALSE, defaultdelayblock.U32delay7)) {
		flash_errno = FE_PHONE_NOT_RESPOND_1;
		return FALSE;
	}
#ifdef USE_BTEMP
	BTEMPLOW(U8baseportval);
	misc_outport(U16baseport, 0, U8baseportval);
	misc_delay(5 * defaultdelayblock.U32delay9);
#endif

	SCLHIGH(U8baseportval);
	misc_outport(U16baseport, 0, U8baseportval);
	misc_delay(5 * defaultdelayblock.U32delay9);

	SCLLOW(U8baseportval);
	misc_outport(U16baseport, 0, U8baseportval);
	misc_delay(5 * defaultdelayblock.U32delay9);

	SCLHIGH(U8baseportval);
	misc_outport(U16baseport, 0, U8baseportval);
	misc_delay(22 * defaultdelayblock.U32delay9);

	FLE5_DirectWriteByteBlock(U16baseport, (UINT8 *) & U16resetcode,
				  sizeof(U16resetcode),
				  defaultdelayblock.U32delay5);

	SCLLOW(U8baseportval);
	misc_outport(U16baseport, 0, U8baseportval);
	misc_delay(10 * defaultdelayblock.U32delay5);

	SCLHIGH(U8baseportval);
	misc_outport(U16baseport, 0, U8baseportval);
	misc_delay(10 * defaultdelayblock.U32delay5);

	if (!FLE5_DirectWaitForEdge
	    (U16baseport, TRUE, defaultdelayblock.U32delay7)) {
		flash_errno = FE_PHONE_NOT_RESPOND_2;
		return FALSE;
	}

	FLE5_DirectReadByteBlock(U16baseport, (UINT8 *) pU32mcuresponse,
				 sizeof(*pU32mcuresponse), 125);
	misc_delay(30 * defaultdelayblock.U32delay9);

	FLE5_DirectWriteByteBlock(U16baseport, (UINT8 *) & U16resetcode,
				  sizeof(U16resetcode),
				  defaultdelayblock.U32delay5);

	if (!FLE5_DirectWaitForEdge
	    (U16baseport, FALSE, defaultdelayblock.U32delay7)) {
		flash_errno = FE_PHONE_NOT_RESPOND_3;
		return FALSE;
	}

	misc_delay(10 * defaultdelayblock.U32delay9);

	/* Hi-Lo */
	FLE5_DirectWriteByteBlock(U16baseport, &U8hisize, sizeof(U8hisize),
				  defaultdelayblock.U32delay5);
	FLE5_DirectWriteByteBlock(U16baseport, &U8losize, sizeof(U8losize),
				  defaultdelayblock.U32delay5);

	if (!FLE5_DirectWaitForEdge
	    (U16baseport, TRUE, defaultdelayblock.U32delay7)) {
		flash_errno = FE_PHONE_NOT_RESPOND_4;
		return FALSE;
	}

	misc_delay(10 * defaultdelayblock.U32delay9);

	FLE5_DirectWriteByteBlock(U16baseport, pAU8buffer, U16size,
				  defaultdelayblock.U32delay5);

	misc_delay(10 * defaultdelayblock.U32delay9);

	if (!FLE5_DirectWaitForEdge
	    (U16baseport, FALSE, defaultdelayblock.U32delay7)) {
		flash_errno = FE_PHONE_NOT_RESPOND_5;
		return FALSE;
	}


	MDBGSTR
	    ("FLE5_DirectInitialiseBootstrapDCT4 : executing bootstrap");
	FLE5_DirectWriteByteBlock(U16baseport, &U8executecmd,
				  sizeof(U8executecmd),
				  defaultdelayblock.U32delay5);

	if (!FLE5_DirectWaitForEdge
	    (U16baseport, TRUE, defaultdelayblock.U32delay7)) {
		flash_errno = FE_PHONE_NOT_RESPOND_6;
		return FALSE;
	}

	MDBGSTR
	    ("FLE5_DirectInitialiseBootstrapDCT4 : preparing reading phone RAM");
	FLE5_DirectWriteByteBlock(U16baseport, &U8executecmd,
				  sizeof(U8executecmd),
				  defaultdelayblock.U32delay5);

	if (!FLE5_DirectWaitForEdge
	    (U16baseport, FALSE, defaultdelayblock.U32delay7)) {
		flash_errno = FE_PHONE_NOT_RESPOND_7;
		return FALSE;
	}

	MDBGSTR
	    ("FLE5_DirectInitialiseBootstrapDCT4 : executing reading phone RAM");
	FLE5_DirectWriteByteBlock(U16baseport, &U8executecmd,
				  sizeof(U8executecmd),
				  defaultdelayblock.U32delay5);

	if (!FLE5_DirectWaitForEdge
	    (U16baseport, TRUE, defaultdelayblock.U32delay7)) {
		flash_errno = FE_PHONE_NOT_RESPOND_8;
		return FALSE;
	}

	misc_delay(10 * defaultdelayblock.U32delay9);
	return TRUE;
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static BOOL FLE5_TickDirectWaitForEdge(UINT16 U16baseport, BOOL Bishigh,
				       UINT32 U32retrycount)
{
	UINT8 U8sda;
	UINT32 U32tickcount;

	Bishigh &= 1;
	Bishigh <<= SDA_IN_BIT;
	U32retrycount *= 100;	/* It's in millisec */

	/* Repeat before tick count checks */
	U8sda = misc_inport(U16baseport, 1);
	U8sda &= SDA_IN_BIT_MASK;
	if (U8sda == Bishigh) {
		return TRUE;
	}


	U32tickcount = misc_gettickcount() + U32retrycount;
	//printf("%i %i\n",misc_gettickcount(),U32tickcount);
	

	while (misc_gettickcount() <= U32tickcount) {
		U8sda = misc_inport(U16baseport, 1);
		U8sda &= SDA_IN_BIT_MASK;
		if (U8sda == Bishigh) {
			return TRUE;
		}
	}

	return FALSE;
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

/* 
static BOOL FLE5_LoopDirectWaitForEdge(UINT16 U16baseport, BOOL Bishigh,
				       UINT32 U32retrycount)
{
	UINT8 U8sda;

	Bishigh &= 1;
	Bishigh <<= SDA_IN_BIT;

	//U32retrycount*=(100*U32microsec_count);
	U32retrycount *= 1000;

	while (U32retrycount > 0) {
		U8sda = misc_inport(U16baseport, 1);
		U8sda &= SDA_IN_BIT_MASK;
		if (U8sda == Bishigh) {
			return TRUE;
		}
		U32retrycount--;
	}

	return FALSE;
}
*/

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static UINT8 FLE5_DirectGetSDA(UINT16 U16baseport)
{
	UINT8 U8sda;

	misc_inport(U16baseport, 0);

	U8sda = ~misc_inport(U16baseport, 1);
	U8sda >>= SDA_IN_BIT;
	U8sda &= 1;

	return U8sda;
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static BOOL FLE5_DirectInitialiseBootstrapDCT3(UINT16 U16baseport,
					       UINT8 * pAU8buffer,
					       UINT16 U16size,
					       UINT32 U32retrycount)
{
	UINT8 U8hisize = MY_HIBYTE(U16size);
	UINT8 U8losize = MY_LOBYTE(U16size);
	UINT8 U8executecmd = 0;
	UINT8 U8baseportval;

	LDBGSTR
	    ("FLE5_DirectInitialiseBootstrapDCT3 : Press power on (if needed)");

	U8baseportval = misc_inport(U16baseport, 0);

	U32retrycount *= 10;

	LDBGSTR("FLE5_DirectInitialiseBootstrapDCT3 : hold SCL low");
	SCLLOW(U8baseportval);	/* hold SCL low */
	misc_outport(U16baseport, 0, U8baseportval);
	misc_delay(defaultdelayblock.U32delay9);

#ifdef USE_BTEMP
	BTEMPHIGH(U8baseportval);
	misc_outport(U16baseport, 0, U8baseportval);
	misc_delay(defaultdelayblock.U32delay9);
#endif
	/* wait for phone poweron */
	LDBGSTR("FLE5_DirectInitialiseBootstrapDCT3 : waiting for poweron (SCL high)");
	if (!FLE5_DirectWaitForEdge(U16baseport, TRUE, U32retrycount)) {
		flash_errno = FE_PHONE_NOT_RESPOND_9;
		return FALSE;
	}
	realtimePriority();
	LDBGSTR("FLE5_DirectInitialiseBootstrapDCT3 : waiting for poweron (SCL low)");
	if (!FLE5_DirectWaitForEdge(U16baseport, FALSE, U32retrycount)) {
		flash_errno = FE_PHONE_NOT_RESPOND_1;
		normalPriority();
		return FALSE;
	}
#ifdef USE_BTEMP
	BTEMPLOW(U8baseportval);
	misc_outport(U16baseport, 0, U8baseportval);
	misc_delay(defaultdelayblock.U32delay9);
#endif
	//LDBGSTR("FLE5_DirectInitialiseBootstrapDCT3 : flasher ID 1");
	/* Flasher identification */
	SCLHIGH(U8baseportval);	/* SCL high */
	misc_outport(U16baseport, 0, U8baseportval);
	misc_delay(defaultdelayblock.U32delay9);
	//LDBGSTR("FLE5_DirectInitialiseBootstrapDCT3 : flasher ID 2");
	SCLLOW(U8baseportval);	/* SCL low */
	misc_outport(U16baseport, 0, U8baseportval);
	misc_delay(defaultdelayblock.U32delay9);
	//LDBGSTR("FLE5_DirectInitialiseBootstrapDCT3 : flasher ID 3");
	SCLHIGH(U8baseportval);	/* SCL high again */
	misc_outport(U16baseport, 0, U8baseportval);
	misc_delay(defaultdelayblock.U32delay9);
	//LDBGSTR("FLE5_DirectInitialiseBootstrapDCT3 : writing size");
	FLE5_DirectWriteByteBlock(U16baseport, &U8hisize, sizeof(U8hisize),
				  defaultdelayblock.U32delay5);
	FLE5_DirectWriteByteBlock(U16baseport, &U8losize, sizeof(U8losize),
				  defaultdelayblock.U32delay5);
	//LDBGSTR("FLE5_DirectInitialiseBootstrapDCT3 : waiting for size ACK");
	/* Wait for SDA high */
	if (!FLE5_DirectWaitForEdge
	    (U16baseport, TRUE, defaultdelayblock.U32delay7)) {
		flash_errno = FE_PHONE_NOT_RESPOND_2;
		normalPriority();
		return FALSE;
	}

	/* Length accepted - send bootstrap */
	//LDBGSTR("FLE5_DirectInitialiseBootstrapDCT3 : size accepted - sending bootstrap");
	FLE5_DirectWriteByteBlock(U16baseport, pAU8buffer, U16size,
				  defaultdelayblock.U32delay5);

	LDBGSTR("FLE5_DirectInitialiseBootstrapDCT3 : waiting for bootstrap");
	/* Wait for SDA low */
	if (!FLE5_DirectWaitForEdge
	    (U16baseport, FALSE, defaultdelayblock.U32delay7)) {
		flash_errno = FE_PHONE_NOT_RESPOND_5;
		normalPriority();
		return FALSE;
	}

	/* Bootstrap is now in memory, and being executed */

	MDBGSTR
	    ("FLE5_DirectInitialiseBootstrapDCT3 : executing bootstrap");
	FLE5_DirectWriteByteBlock(U16baseport, &U8executecmd,
				  sizeof(U8executecmd),
				  defaultdelayblock.U32delay5);

	if (!FLE5_DirectWaitForEdge
	    (U16baseport, TRUE, defaultdelayblock.U32delay7)) {
		flash_errno = FE_PHONE_NOT_RESPOND_6;
		normalPriority();
		return FALSE;
	}
	normalPriority();

	MDBGSTR
	    ("FLE5_DirectInitialiseBootstrapDCT3 : preparing reading phone RAM");
	FLE5_DirectWriteByteBlock(U16baseport, &U8executecmd,
				  sizeof(U8executecmd),
				  defaultdelayblock.U32delay5);

	if (!FLE5_DirectWaitForEdge
	    (U16baseport, FALSE, defaultdelayblock.U32delay7)) {
		flash_errno = FE_PHONE_NOT_RESPOND_7;
		return FALSE;
	}

	MDBGSTR
	    ("FLE5_DirectInitialiseBootstrapDCT3 : executing reading phone RAM");
	FLE5_DirectWriteByteBlock(U16baseport, &U8executecmd,
				  sizeof(U8executecmd),
				  defaultdelayblock.U32delay5);

	if (!FLE5_DirectWaitForEdge
	    (U16baseport, TRUE, defaultdelayblock.U32delay7)) {
		flash_errno = FE_PHONE_NOT_RESPOND_8;
		return FALSE;
	}

	misc_delay(10 * defaultdelayblock.U32delay9);
	return TRUE;
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static void FLE5_DirectWriteByte(UINT16 U16baseport, UINT8 * U8baseportval,
				 UINT8 U8byte, UINT32 U32delay)
{
	UINT8 i;
#ifdef DEBUG_WRITEBYTE_ACK
	UINT8 U8origbyte = U8byte, U8bitack, U8ack = 0;
#endif
	//printf("WriteByte %08x\n", U8byte);
	for (i = 0; i < 8; i++) {
#ifdef DEBUG_WRITEBYTE_ACK
		U8ack <<= 1;
		U8bitack =
		    FLE5_DirectWriteBit(U16baseport, U8baseportval,
					(U8byte & 1) + 1, TRUE, U32delay,
					FALSE, 0);
		U8ack |= U8bitack;
#else
		/*
		   static UINT8 FLE5_DirectWriteBit(
		   UINT16 U16baseport,
		   UINT8 *U8baseportval,
		   UINT8 U8high,BOOL Bscllow,UINT32 U32delay6,BOOL Bextradelay,UINT32 U32delay5)
		 */
		FLE5_DirectWriteBit(U16baseport,
				    U8baseportval,
				    (UINT8) ((U8byte & 1) + 1),
				    TRUE, U32delay, FALSE, 0);
#endif
		U8byte >>= 1;
	}

#ifdef DEBUG_WRITEBYTE_ACK
	MDBGSTR2("TX8 %02x(%02x)", U8origbyte, U8ack);
#endif
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static void FLE5_DirectWriteByteBlock(UINT16 U16baseport,
				      UINT8 * pAU8buffer, UINT32 U32size,
				      UINT32 U32delay)
{
	UINT8 U8baseportval;

	U8baseportval = misc_inport(U16baseport, 0);

	if (U32size == 0)
		return;

	do {
	        //printf("%02x\n", *pAU8buffer);
		FLE5_DirectWriteByte(U16baseport, &U8baseportval,
				     *pAU8buffer, U32delay);
		pAU8buffer++;
	} while ((--U32size) > 0);
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static void FLE5_DirectReadByteBlock(UINT16 U16baseport,
				     UINT8 * pAU8buffer, UINT32 U32size,
				     UINT32 U32delay)
{
	UINT8 U8baseportval;

	U8baseportval = misc_inport(U16baseport, 0);

	if (U32size == 0)
		return;

	do {
		*(pAU8buffer++) =
		    FLE5_DirectReadByte(U16baseport, &U8baseportval,
					U32delay, FALSE, 0);
	} while ((--U32size) > 0);
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static BOOL FLE5_DirectWriteByteBlockAndTrigger(UINT16 U16baseport,
						UINT8 * pAU8buffer,
						UINT32 U32size,
						UINT32 U32cmd,
						tFLS1_DELAYBLOCK *
						pdelayblock)
{
	UINT8 U8baseportval;
	UINT8 U8sda;
	UINT32 U32delay;

	U8baseportval = misc_inport(U16baseport, 0);
	SCLHIGH(U8baseportval);
	misc_outport(U16baseport, 0, U8baseportval);

	if (!pdelayblock) {
		pdelayblock = &defaultdelayblock;
	}

	if ((U32size--) == 0) {
		return TRUE;
	}

	U32delay =
	    (((U32cmd & FLE5_AFTER_READ_EXTRADELAY)
	      && (pdelayblock->U32delay5 >
		  0)) ? pdelayblock->U32delay5 : 0);

	do {
		FLE5_DirectWriteByte(U16baseport, &U8baseportval,
				     *pAU8buffer, U32delay);
		pAU8buffer++;

		if ((U32cmd & FLE5_AFTER_WRITE_CHECK_SDA) ||
		    ((U32size == 1)
		     && (U32cmd & FLE5_AFTER_WRITE_CHECK_SDA)
		     && (U32cmd & FLE5_AFTER_WRITE_WAIT_FOR_SDA))) {
			U8sda = misc_inport(U16baseport, 1);
			U8sda &= SDA_IN_BIT_MASK;
			if (!U8sda) {	/* inverted SDA */
				flash_errno = FE_INVALID_DATA_FROM_PHONE;
				return FALSE;
			}
		}

		if (U32cmd & FLE5_AFTER_WRITE_DELAY) {
			misc_delay(10 * pdelayblock->U32delay1);
		}

	} while ((U32size--) > 0);

	if (U32cmd & FLE5_AFTER_WRITE_FINAL_DELAY) {
		HDBGSTR1
		    ("FLE5_DirectWriteByteBlockAndTrigger : delaying for %d microsec",
		     10 * pdelayblock->U32delay4);
		misc_delay(10 * pdelayblock->U32delay4);
	}

	return TRUE;
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static BOOL FLE5_DirectWriteByteBlockAndSDA(UINT16 U16baseport,
					    UINT8 * pAU8buffer,
					    UINT32 U32size, UINT32 U32cmd,
					    tFLS1_DELAYBLOCK * pdelayblock)
{
	UINT8 U8baseportval;
	UINT8 U8sda;
	UINT8 U8count;
	UINT8 U8limit;
	BOOL Bcheck;
	UINT32 U32delay;

	if (U32cmd & FLE5_DIRECT_STRANGE_WRITE2) {
		U8limit = 1;
	} else {
		U8limit =
		    (UINT8) ((misc_calculatelimit(U32cmd, 0x800) & 2) + 2);
	}

	U8count = 0;

	U8baseportval = misc_inport(U16baseport, 0);

	U8sda = ~misc_inport(U16baseport, 1);
	U8sda >>= SDA_IN_BIT;
	U8sda &= 1;
	Bcheck = U8sda;

	if (!pdelayblock) {
		pdelayblock = &defaultdelayblock;
	}

	if ((U32size--) == 0) {
		return TRUE;
	}

	U32delay =
	    (((U32cmd & FLE5_AFTER_READ_EXTRADELAY)
	      && (pdelayblock->U32delay5 >
		  0)) ? pdelayblock->U32delay5 : 0);

	do {
		FLE5_DirectWriteByte(U16baseport, &U8baseportval,
				     *pAU8buffer, U32delay);
		pAU8buffer++;

		if (++U8count == U8limit) {
			U8count = 0;
			if (!FLE5_DirectWaitForEdge
			    (U16baseport, Bcheck,
			     pdelayblock->U32delay2)) {
				MDBGSTR1
				    ("FLE5_DirectWriteByteBlockAndSDA : bad ack is received (other than %d)",
				     Bcheck);
				flash_errno = FE_INVALID_RESPONSE_FROM_SDA;
				return FALSE;
			}
			Bcheck = !Bcheck;
		}
	} while ((U32size--) > 0);

	return TRUE;
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static UINT8 FLE5_DirectWriteBit(UINT16 U16baseport, UINT8 * U8baseportval,
				 UINT8 U8high, BOOL Bscllow,
				 UINT32 U32delay6, BOOL Bextradelay,
				 UINT32 U32delay5)
{
	UINT8 U8byte = 0;

	// SDAHIGH or SDALOW
	if (U8high > 0) {
		if (U8high == 2)
			SDAHIGH(*U8baseportval);
		else
			SDALOW(*U8baseportval);

		misc_outport(U16baseport, 0, *U8baseportval);
		misc_delay(U32delay6);
		if (Bextradelay) {
			misc_delay(10 * U32delay5);
		}
	}
	// SCLLOW is needed
	if (Bscllow) {
		SCLLOW(*U8baseportval);
		misc_outport(U16baseport, 0, *U8baseportval);
		misc_delay(U32delay6);
		if (Bextradelay) {
			misc_delay(10 * U32delay5);
		}
	}

	if (misc_inport(U16baseport, 1) & SDA_IN_BIT_MASK)
		U8byte = 1;

	// SCLHIGH
	SCLHIGH(*U8baseportval);
	misc_outport(U16baseport, 0, *U8baseportval);
	misc_delay(U32delay6);
	if (Bextradelay) {
		misc_delay(10 * U32delay5);
	}

	return U8byte;
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static UINT8 FLE5_DirectReadByte(UINT16 U16baseport, UINT8 * U8baseportval,
				 UINT32 U32delay6, BOOL Bextradelay,
				 UINT32 U32delay5)
{
	UINT8 i, U8byte = 0;

	for (i = 0; i < 8; i++) {
		U8byte >>= 1;
		if (FLE5_DirectWriteBit
		    (U16baseport, U8baseportval, 0, TRUE, U32delay6,
		     Bextradelay, U32delay5))
			U8byte |= 0x80;
	}

	return U8byte;
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static void FLE5_DirectGeneralReadByteBlock(UINT16 U16baseport,
					    UINT8 * pAU8buffer,
					    UINT32 U32size, UINT32 U32cmd,
					    tFLS1_DELAYBLOCK * pdelayblock)
{
	UINT8 U8baseportval;
#ifdef DEBUG_READBYTE
	UINT8 U8byte;
#endif
	BOOL Bextradelay;

	if (!pdelayblock) {
		pdelayblock = &defaultdelayblock;
	}

	U8baseportval = misc_inport(U16baseport, 0);

	if (U32size == 0)
		return;

	Bextradelay = (U32cmd & FLE5_AFTER_READ_EXTRADELAY) != 0;

	do {
#ifdef DEBUG_READBYTE
		U8byte = *(pAU8buffer++) =
		    FLE5_DirectReadByte(U16baseport, &U8baseportval,
					pdelayblock->U32delay6,
					Bextradelay,
					pdelayblock->U32delay5);
		MDBGSTR2("RX8 %02x(%c)", U8byte,
			 (U8byte < 32 ? 32 : U8byte));
#else
		*(pAU8buffer++) =
		    FLE5_DirectReadByte(U16baseport, &U8baseportval,
					pdelayblock->U32delay6,
					Bextradelay,
					pdelayblock->U32delay5);
#endif

		if (U32cmd & FLE5_AFTER_WRITE_DELAY) {
			misc_delay(10 * pdelayblock->U32delay1);
		}

	} while ((--U32size) > 0);

	if (U32cmd & FLE5_AFTER_WRITE_FINAL_DELAY) {
		HDBGSTR1
		    ("FLE5_DirectGeneralReadByteBlock : delaying for %d microsec",
		     10 * pdelayblock->U32delay4);
		misc_delay(10 * pdelayblock->U32delay4);
	}
}

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static void FLE5_DirectSetIdleState(UINT16 U16baseport, UINT32 U32mode)
{
	UINT8 U8baseportval = 0x00;
	UINT8 U8reset;
	if (U32mode & FLE5_DIRECT_IDLE_MODE1) {
		U8reset =
		    (U32mode & FLE5_DIRECT_IDLE_MODE2
		     ? (SDA_OUT_BIT_MASK | SCL_OUT_BIT_MASK) : 0);
		misc_outport(U16baseport, 0, U8reset);
		return;
	}

	misc_outport(U16baseport, 0, U8baseportval);
	misc_delay(10000 * defaultdelayblock.U32delay9);

	SCLHIGH(U8baseportval);
	SDAHIGH(U8baseportval);
	misc_outport(U16baseport, 0, U8baseportval);
	misc_delay(10000 * defaultdelayblock.U32delay9);

	SCLLOW(U8baseportval);
	SDALOW(U8baseportval);
	VPPHIGH(U8baseportval);
	misc_outport(U16baseport, 0, U8baseportval);
	BTEMPLOW(U8baseportval);
	misc_outport(U16baseport, 0, U8baseportval);
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

BOOL FLE5_InitialiseBootstrapDCT3(UINT16 U16baseport, UINT8 * pAU8buffer,
				  UINT16 U16size, UINT32 U32retrycount)
{
	return FLE5_DirectInitialiseBootstrapDCT3(U16baseport, pAU8buffer,
						  U16size, U32retrycount);
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

BOOL FLE5_InitialiseBootstrapDCT4(UINT16 U16baseport, UINT8 * pAU8buffer,
				  UINT16 U16size, UINT32 * pU32mcuresponse)
{
	return FLE5_DirectInitialiseBootstrapDCT4(U16baseport, pAU8buffer,
						  U16size,
						  pU32mcuresponse);
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static BOOL FLE5_FuncSendToPhone(UINT16 U16baseport, UINT8 * pAU8buffer,
				 UINT32 U32size, UINT32 U32cmd,
				 tFLS1_DELAYBLOCK * pdelayblock)
{
	UINT32 U32localcmd = U32cmd & FLE5_WRITE_TYPE_MODE;

	if (U32localcmd) {
		if (U32localcmd == FLE5_WRITE_TYPE_MODE)
			return FALSE;

		return FLE5_DirectWriteByteBlockAndSDA(U16baseport,
						       pAU8buffer, U32size,
						       U32cmd,
						       pdelayblock);
	}

	return FLE5_DirectWriteByteBlockAndTrigger(U16baseport, pAU8buffer,
						   U32size, U32cmd,
						   pdelayblock);
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static BOOL FLE5_ExecuteCommand(UINT16 U16baseport, UINT32 U32cmd,
				tFLS1_DELAYBLOCK * pdelayblock)
{
	UINT8 U8executecmd = 0xFF;
	UINT32 U32writecmd;
	BOOL Bsuccess;

	if (U32cmd & FLE5_WAITFOREDGE_LOW) {
		if (!FLE5_DirectWaitForEdge
		    (U16baseport, FALSE, pdelayblock->U32delay2)) {
			MDBGSTR
			    ("FLE5_ExecuteCommand : commandblock not accepted");
			flash_errno = FE_INVALID_RESPONSE_FROM_SDA;
			return FALSE;
		}
		HDBGSTR("FLE5_ExecuteCommand : commandblock accepted");
	}

	if (U32cmd & FLE5_EXECUTESTREAM) {
		U32writecmd = 0;
		Bsuccess =
		    FLE5_FuncSendToPhone(U16baseport, &U8executecmd,
					 sizeof(U8executecmd), U32writecmd,
					 pdelayblock);
		if (!Bsuccess) {
			return FALSE;
		}
		HDBGSTR("FLE5_ExecuteCommand : execution command sent");
	}

	if (U32cmd & FLE5_WAITFOREDGE_HIGH) {
		if (!FLE5_DirectWaitForEdge
		    (U16baseport, TRUE, pdelayblock->U32delay3)) {
			MDBGSTR
			    ("FLE5_ExecuteCommand : could not execute command");
			flash_errno = FE_INVALID_RESPONSE_FROM_SDA2;
			return FALSE;
		}
		HDBGSTR("FLE5_ExecuteCommand : command executed");
	}

	return TRUE;
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static BOOL FLE5_AfterReadWriteTrigger(UINT16 U16baseport, UINT32 U32cmd,
				       tFLS1_DELAYBLOCK * pdelayblock)
{
	BOOL Bsuccess = TRUE /* default */ ;
	UINT32 U32delay;

	if (!pdelayblock) {
		pdelayblock = &defaultdelayblock;
	}

	if (U32cmd & FLE5_EXECUTE_CMD) {
		Bsuccess =
		    FLE5_ExecuteCommand(U16baseport, U32cmd, pdelayblock);
	}

	if (U32cmd & FLE5_DELAY_AFTER_READWRITE) {
		U32delay = FLE5_MAJIC_NUMBER % pdelayblock->U32delay4;
		U32delay >>= 5;
		U32delay++;
		HDBGSTR1
		    ("FLE5_AfterReadWriteTrigger : delaying for %d microsec",
		     U32delay);
		misc_sleep(U32delay);
	}

	return Bsuccess;
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

BOOL FLE5_SendToPhone(UINT16 U16baseport, UINT8 * pAU8buffer,
		      UINT32 U32size, UINT32 U32cmd,
		      tFLS1_DELAYBLOCK * pdelayblock)
{
	BOOL Bsuccess;

	Bsuccess =
	    FLE5_FuncSendToPhone(U16baseport, pAU8buffer, U32size, U32cmd,
				 pdelayblock);
	if (!Bsuccess) {
		return FALSE;
	}

	Bsuccess =
	    FLE5_AfterReadWriteTrigger(U16baseport, U32cmd, pdelayblock);

	return Bsuccess;
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

static void FLE5_FuncReceiveFromPhone(UINT16 U16baseport,
				      UINT8 * pAU8buffer, UINT32 U32size,
				      UINT32 U32cmd,
				      tFLS1_DELAYBLOCK * pdelayblock)
{
	FLE5_DirectGeneralReadByteBlock(U16baseport, pAU8buffer, U32size,
					U32cmd, pdelayblock);
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

BOOL FLE5_ReceiveFromPhone(UINT16 U16baseport, UINT8 * pAU8buffer,
			   UINT32 U32size, UINT32 U32cmd,
			   tFLS1_DELAYBLOCK * pdelayblock)
{
	BOOL Bsuccess;

	FLE5_FuncReceiveFromPhone(U16baseport, pAU8buffer, U32size, U32cmd,
				  pdelayblock);

	Bsuccess =
	    FLE5_AfterReadWriteTrigger(U16baseport, U32cmd, pdelayblock);

	return Bsuccess;
}

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

BOOL FLE5_WaitForEdge(UINT16 U16baseport, BOOL Bishigh,
		      UINT32 U32retrycount)
{
	return FLE5_DirectWaitForEdge(U16baseport, Bishigh, U32retrycount);
}

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

UINT8 FLE5_GetSDA(UINT16 U16baseport)
{
	return FLE5_DirectGetSDA(U16baseport);
}

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

void FLE5_SetIdleState(UINT16 U16baseport, UINT32 U32mode)
{
	FLE5_DirectSetIdleState(U16baseport, U32mode);
}

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

void FLE5_SetDefaultTimes(tFLS1_DELAYBLOCK * pdelayblock)
{
	memcpy(&defaultdelayblock, pdelayblock, sizeof(tFLS1_DELAYBLOCK));
}

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

void FLE5_GetDefaultTimes(tFLS1_DELAYBLOCK * pdelayblock)
{
	memcpy(pdelayblock, &defaultdelayblock, sizeof(tFLS1_DELAYBLOCK));
}
