

/********************************************************************
*                                                                   *
* FILE NAME:                                                        *
*                                                                   *
* PURPOSE:                                                          *
*                                                                   *
* FILE REFERENCES:                                                  *
*                                                                   *
* Name:                                                             *
*                                                                   *
* I/O:                                                              *
*                                                                   *
* Description:                                                      *
*                                                                   *
* EXTERNAL VARIABLES:                                               *
*                                                                   *
* Source:  <      >                                                 *
*                                                                   *
* Name:                                                             *
*                                                                   *
* Type:                                                             *
*                                                                   *
* I/O:                                                              *
*                                                                   *
* Description:                                                      *
*                                                                   *
*                                                                   *
* EXTERNAL REFERENCES:                                              *
*                                                                   *
* Name:                                                             *
*                                                                   *
* Description:                                                      *
*                                                                   *
*                                                                   *
* ABNORMAL TERMINATION CONDITIONS, ERROR AND WARNING MESSAGES:      *
*                                                                   *
* ASSUMPTIONS, CONSTRAINTS, RESTRICTIONS:                           *
*                                                                   *
* NOTES:                                                            *
*                                                                   *
* REQUIREMENTS/FUNCTIONAL SPECIFICATIONS REFERENCES:                *
*                                                                   *
* DEVELOPMENT HISTORY:                                              *
*                                                                   *
* Date:                                                             *
*                                                                   *
* Author:                                                           *
*                                                                   *
* Change Id:                                                        *
*                                                                   *
* Release:                                                          *
*                                                                   *
* Description of change:                                            *
*                                                                   *
********************************************************************/
#include "../include/config.h"


#ifdef WIN32
#include <windows.h>
#include <largeint.h>
#include <conio.h>
#else
#include <time.h>
#include <sys/time.h>
#include <asm/io.h> /* for inb and outb */
#include <sched.h>
#endif

#include <string.h>
#include <stdio.h>

#include "../include/sysdef.h"
#ifdef GENERAL_PORT
#include "portpub.h"
#endif
#include "../include/fls1pub.h"
#include "miscloc.h"
#include "miscpub.h"

//pDelayFunc misc_delay = NULL;

char logbuffer[SYS_MAX_LOGSTRING_LEN];
FILE *logfile = NULL;
eREDIRECTION_TYPE eRedirection = REDIRECTION_TYPE_NONE;

//UINT32 U32microsec_count = 0;

static const UINT16 EPP_LPT_ADDRESSES[] = { 0x378, 0x278, 0x3bc };
static pLogCallout logcallout = NULL;

void realtimePriority() {
	struct sched_param  sch;
	/* set priority */
	//sched_getscheduler(0);
	sch.sched_priority = sched_get_priority_max(SCHED_RR);
	if(sched_setscheduler(0, SCHED_RR, &sch) != 0) {
		HDBGSTR("Could not set scheduling priority\n");
		perror("Bla\n");
	} else {
		HDBGSTR(":DANGER: realtime priority enabled\n");
	}
	
}


void normalPriority() {
	struct sched_param  sch;
	/* set priority */
	//sched_getscheduler(0);
	sch.sched_priority = sched_get_priority_max(SCHED_OTHER);
	if(sched_setscheduler(0, SCHED_OTHER, &sch) != 0) {
		printf("Could not set scheduling priority\n");
		perror("Bla\n");
	} else {
		printf(":DANGER: realtime priority dropped\n");
	}
	
}



/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

void misc_handlelogstring(BOOL Biserror, BOOL Bshowaserror)
{
	if (logfile != NULL
	    && (eRedirection == REDIRECTION_TYPE_SAVE_TO_FILE
		|| eRedirection == REDIRECTION_TYPE_REDIRECT_TO_FILE)) {
		fprintf(logfile, "%s\n", logbuffer);
	}

	if (eRedirection == REDIRECTION_TYPE_SAVE_TO_FILE
	    || eRedirection == REDIRECTION_TYPE_NONE) {
		if (logcallout)
			logcallout(logbuffer, Biserror, Bshowaserror);
	}
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/
/* NO*ASM */
void misc_outport(UINT16 U16port, SINT16 S16shift, UINT8 U8byte)
{
#ifdef WIN32
	_outp((UINT16) (U16port + S16shift), U8byte);
#else
	outb(U8byte, U16port + S16shift);
#endif
	/*
	   mov dx,[U16port]
	   add dx,[S16shift]
	   mov al,[U8byte]
	   out dx,al
	 */

#ifdef DEBUG_OUTPORTACTIVITY
	MDBGSTR1("OUTB: %02X", U8byte);
#endif
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

UINT8 misc_inport(UINT16 U16port, SINT16 S16shift)
{
	UINT8 U8ret = 0;
#ifdef WIN32	
	U8ret = _inp((UINT16) (U16port + S16shift));
#else
	U8ret = inb(U16port + S16shift);
#endif
	/*
	   asm mov dx,[U16port]
	   asm add dx,[S16shift]
	   asm in al,dx
	   asm mov [U8ret],al
	 */

#ifdef DEBUG_INPORTACTIVITY
	MDBGSTR1("INB: %02X", U8ret);
#endif
	return U8ret;
}


#ifdef WIN32
static int _usleep_warned = 0;
static void _usleep(int us)
{
	/*
	 * FROM: SCTHV source
	 * An implementation of usleep for windows
	 * This function uses the high performance counter from the windows 
	 * API.  The performance of this counter may be expected to depend 
	 * upon processor type and speed, however during tests with a 2GHz 
	 * P4 system and with a 350MHz PII I got the same result: a maximum
	 * latency of 5microS.  Hence this approach seems reasonable
	 * for time intervals down to 10 (+5/-0) microS.
	 * PWP 04.07.02
	 */

	LARGE_INTEGER lFreq;
	LARGE_INTEGER lStart, lCount;
	unsigned __int64 lDiff;
	double delay, freq, target;

	if (!QueryPerformanceCounter(&lStart)) {
		if (!_usleep_warned) {
			_usleep_warned = 1;
			INFO("QueryPerformanceCounter not supported on this system - using very low resolution timing.");
		}
		/* uh oh .. no supported hardware 
		   low resolution alternative ... */
		Sleep((us + 999) / 1000);
		return;
	}

	QueryPerformanceFrequency(&lFreq);
	freq = (double) lFreq.LowPart;

	target = ((double) us) / ((double) 1000000);

	delay = 0;
	while (delay < target) {
		QueryPerformanceCounter(&lCount);
		lDiff = lCount.QuadPart - lStart.QuadPart;
		delay = ((UINT32) lDiff) / freq;
	}
	return;
}
#else
#define _usleep usleep
#endif

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

/*
static UINT32 misc_mul64(UINT32 U32src_hi,UINT32 U32src_lo)
{

//  asm mov edx,[U32src_hi]
//  asm mov eax,[U32src_lo]
//  asm mul edx
//  asm mov eax,edx

  return (UINT32)((UINT64) U32src_hi*U32src_lo)>>32;
}
*/

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

/*
static UINT32 misc_rdtsc(void)
{
  asm db 0Fh; 
  asm db 31h;	// in rdtsc edx:eax the value, we only need the low dword
}
*/

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

/*
void misc_calibrate_delay(void)
{
}
*/


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

void misc_usleep(UINT32 U32count)
{				/* shall be in microsec */
	//printf("%08X\n", U32count);
#ifdef WIN32
	_usleep(U32count);
#else
	//printf("%i\n", U32count);
	/*
	struct timespec req;
	req.tv_nsec = U32count*100;
	req.tv_sec = 0;
        nanosleep(&req, NULL);
        */
        int x;
        for(x=0; x<U32count; x++)
        	inb(0x378);
	/*
	struct timespec s;
	s.tv_sec = 0;
	s.tv_nsec = 1;
	nanosleep(&s, NULL);
	*/
#endif
}

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

/*
void misc_rdtscdelay(UINT32 x)
{
  UINT32 __U32t0 = misc_mul64(U32loops_per_jiffy,x*0x000010c6); 
  __delay(__U32t0 * HZ);
}
*/

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

UINT16 misc_swapword(UINT16 U16word)
{
	return ((U16word >> 8) & 0xFF) | (U16word << 8);
	/*
	   UINT16 U16ret;

	   asm mov ax,[U16word]
	   asm xchg al,ah
	   asm mov [U16ret],ax

	   return U16ret;
	 */
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

UINT32 misc_swapdword(UINT32 U32dword)
{
	UINT16 U16hiword, U16loword;

	U16hiword = misc_swapword(MY_HIWORD(U32dword));
	U16loword = misc_swapword(MY_LOWORD(U32dword));

	return (((UINT32) (U16loword)) << 16) | U16hiword;
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

UINT8 misc_calculatelimit(UINT32 U32limit, UINT32 U32and)
{
	if ((U32limit & U32and) == 0)
		return 0;
	else
		return 0xFF;

	/*
	   UINT8 U8ret;

	   asm mov eax,[U32limit]
	   asm and eax,[U32and]
	   asm neg eax
	   asm sbb al,al
	   asm mov [U8ret],al

	   return U8ret;
	 */
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

UINT32 misc_gettickcount(void)
{
#ifdef WIN32
	return GetTickCount();
#else
	struct timeval tv;
	gettimeofday(&tv, NULL);
	UINT32 ticks = ((tv.tv_sec%1000000)*1000)+(tv.tv_usec/1000);
	//printf("ticks: %08X\n",ticks);
	return ticks;
#endif
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

UINT16 misc_calculate16bitchecksum(BOOL Bswap, BOOL Bnegate,
				   UINT8 * pAU8buffer, size_t length)
{
	size_t i;
	UINT16 U16chk, U16retchk;
	UINT16 *pAU16buffer = (UINT16 *) pAU8buffer;

	for (i = 0, U16chk = 0; i < length; i++, pAU16buffer++) {
		U16chk += misc_swapword(*pAU16buffer);
	}

	if (Bnegate)
		U16retchk = 0 - U16chk;
	else
		U16retchk = U16chk;

	if (Bswap)
		U16retchk = misc_swapword(U16retchk);

	return U16retchk;
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

UINT8 misc_calculate8bitchecksum(UINT8 * pAU8buffer, size_t length)
{
	size_t i;
	UINT8 U8chk;

	for (i = 0, U8chk = 0; i < length; i++, pAU8buffer++) {
		U8chk += (*pAU8buffer);
	}

	return (0xff - U8chk);
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

UINT8 misc_calculate8bitchecksumas16bit(UINT8 * pAU8buffer, size_t length)
{
	size_t i;
	UINT16 U16chk;

	for (i = 0, U16chk = 0; i < length; i++, pAU8buffer++) {
		U16chk += (*pAU8buffer);
	}

	return (UINT8) U16chk;
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

BOOL misc_check8bitchecksum(UINT8 * pAU8buffer, size_t length)
{
	size_t i;
	UINT8 U8chk;

	for (i = 0, U8chk = 0; i < length; i++, pAU8buffer++) {
		U8chk += (*pAU8buffer);
	}

	return (U8chk == 0xFF);
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

void misc_sleep(UINT32 U32count)
{				/* in milliseconds */
#ifdef WIN32
	Sleep(U32count);
#else
	usleep(U32count*1000);
#endif
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

UINT32 misc_getfilesize(FILE * rfile)
{
	UINT32 U32length;

	fseek(rfile, 0L, SEEK_END);
	U32length = ftell(rfile);
	HDBGSTR1("misc_getfilesize : length of file is %d", U32length);
	fseek(rfile, 0L, SEEK_SET);

	return U32length;
}

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

UINT16 misc_getLPTport(UINT16 U16portid)
{
	if (U16portid < 1 || U16portid > 3)
		return 0;

	return EPP_LPT_ADDRESSES[U16portid - 1];
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

SINT32 misc_getMCUversion(UINT8 * MCUversion)
{
	UINT8 *pchar, *pend, *pstart = MCUversion;
	SINT32 S32version;
	char version[8];

	/* V XX.YY */
	pchar = (UINT8 *) strchr((char *) MCUversion, '.');
	if (!pchar)
		return -1;

	S32version = atoi((char *) pchar + 1);

	pend = (UINT8 *) strchr((char *) MCUversion, '\n');
	if (!pend)
		return -1;

	memset(version, 0, sizeof(version));
	if (pchar - pstart > sizeof(version))
		return -1;

	strncpy(version, (char *) pstart, pchar - pstart);
	pchar = (UINT8 *) & version[0];
	pend = pchar + sizeof(version);
	while ((*pchar < '0' || *pchar > '9') && pchar < pend)
		pchar++;

	S32version += (SINT32) 256 *atoi((char *) pchar);

	return S32version;
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

UINT8 misc_hexchartobyte(char hex)
{
	if (hex >= 'A' && hex <= 'F')
		return (UINT8) hex - 55;
	else if (hex >= 'a' && hex <= 'f')
		return (UINT8) hex - 87;
	else if (hex >= '0' && hex <= '9')
		return (UINT8) hex - 48;

	return 0;
}

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

UINT32 misc_hextodword(char *hex)
{
	UINT32 U32ret = 0;
	UINT16 U16hexlen = strlen(hex);
	SINT16 i;
	UINT32 U32exp = 1;

	for (i = U16hexlen - 1; i >= 0; i--, U32exp *= 16)
		U32ret += (U32exp * misc_hexchartobyte(hex[i]));

	return U32ret;
}

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

char misc_chartohexchar(UINT8 U8char)
{
	U8char &= 0x0F;

	if (U8char > 9)
		U8char += 'A' - 10;
	else
		U8char += '0';

	return (char) U8char;
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

void misc_dwordtohex(UINT32 U32dword, char *hex)
{
	char chr[8];
	UINT8 U8num_of_chrs = 0;
	SINT8 i, j;

	do {
		chr[U8num_of_chrs++] =
		    misc_chartohexchar((UINT8) (U32dword & 0xF));
		U32dword >>= 4;
	} while (U32dword != 0);

	for (j = 0, i = U8num_of_chrs - 1; i >= 0; i--, j++)
		hex[j] = chr[i];

	hex[j] = 0;
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

BOOL misc_startredirectionoferror(char *filename)
{
	if (eRedirection != REDIRECTION_TYPE_NONE) {
		logfile = fopen(filename, "wt");

		if (logfile == NULL)
			return FALSE;
	}

	return TRUE;
}

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

void misc_finishredirectionoferror(void)
{
	if (eRedirection != REDIRECTION_TYPE_NONE && logfile != NULL)
		fclose(logfile);
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

UINT32 misc_calculate32bitchecksum(BOOL Bswap, BOOL Bnegate,
				   UINT8 * U8buffer, UINT32 U32length)
{
	UINT32 i;
	UINT32 U32chk = 0, U32retchk;
	UINT32 *pU32buff = (UINT32 *) U8buffer;

	for (i = 0; i < U32length; i++, pU32buff++) {
		U32chk += misc_swapdword(*pU32buff);
	}

	if (Bnegate)
		U32retchk = 0 - U32chk;
	else
		U32retchk = U32chk;

	if (Bswap)
		U32retchk = misc_swapdword(U32retchk);

	return U32retchk;
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

SINT32 misc_memstr(UINT8 * pU8src, UINT32 U32srclen, UINT8 * pU8dst,
		   UINT32 U32dstlen)
{
	UINT32 i;
	BOOL Bfound;

	for (i = 0, Bfound = FALSE; i < U32srclen - U32dstlen && !Bfound;
	     i++)
		Bfound = memcmp(pU8src + i, pU8dst, U32dstlen) == 0;

	return (Bfound ? i : -1);
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

BOOL misc_readheader(FILE * rfile, eFILE_TYPE * file_type,
		     UINT32 * U32startaddr)
{
	tFILE_HEADER header;
	UINT8 U8read;
	UINT8 U8checksum;

	memset(&header, 0, sizeof(header));

	fseek(rfile, 0L, SEEK_SET);
	U8read = fread(&header, sizeof(tFILE_HEADER), 1, rfile);
	if (U8read != 1) {
		HDBGSTR("misc_readheader : invalid size of header");
		return FALSE;
	}

	if (header.U32id != KNOK_HEADER_ID) {
		HDBGSTR("misc_readheader : invalid header id in header");
		return FALSE;
	}

	U8checksum =
	    misc_calculate8bitchecksum((UINT8 *) & header,
				       sizeof(tFILE_HEADER) -
				       sizeof(header.U32checksum));
	HDBGSTR2
	    ("misc_readheader : calculated checksum is %lX, original is %lX",
	     U8checksum, header.U32checksum);
	if (U8checksum != (UINT8) header.U32checksum) {
		HDBGSTR("misc_readheader : checksum is bad");
		return FALSE;
	}

	*U32startaddr = header.U32startaddr;
	*file_type = header.filetype;

	return TRUE;
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

BOOL misc_writeheader(FILE * rfile, eFILE_TYPE file_type,
		      UINT32 U32startaddr)
{
	tFILE_HEADER header;
	UINT8 U8written;

	memset(&header, 0, sizeof(header));

	header.U32startaddr = U32startaddr;
	header.U32id = KNOK_HEADER_ID;
	header.filetype = file_type;
	/* without checksum */
	header.U32checksum =
	    misc_calculate8bitchecksum((UINT8 *) & header,
				       sizeof(tFILE_HEADER) -
				       sizeof(header.U32checksum));
	U8written = fwrite(&header, sizeof(tFILE_HEADER), 1, rfile);
	if (U8written != 1) {
		return FALSE;
	}

	return TRUE;
}

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

void misc_setredirection(eREDIRECTION_TYPE redirecttype)
{
	eRedirection = redirecttype;
	HDBGSTR1("misc_setredirection : redirection is %d", redirecttype);
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

void misc_setlogcallout(pLogCallout desiredlogcallout)
{
	logcallout = desiredlogcallout;
}


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/
/*
void misc_setdelayfunc(pDelayFunc delayfunc)
{
  misc_delay = delayfunc;
}
*/


/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/
/*
void misc_setbasedelay(UINT32 U32delay)
{
  U32microsec_count = U32delay;
}
*/

/********************************************************
*                                                       *
* FUNCTION NAME:                                        *
*                                                       *
* ARGUMENTS:                                            *
*                                                       *
* ARGUMENT NAME:                                        *
*                                                       *
* TYPE:                                                 *
*                                                       *
* I/O:                                                  *
*                                                       *
* DESCRIPTION                                           *
*                                                       *
*                                                       *
* RETURNS:                                              *
*                                                       *
*********************************************************/

void misc_checkfilename(char *filename)
{
	char ext[16], timeanddate[64], newname[SYS_MAX_PATHNAME_LEN];
#ifdef WIN32
	SYSTEMTIME systime;
#else
	time_t timep;
	struct tm systime;
#endif
	char *pext;
	FILE *rfile;

	rfile = fopen(filename, "rb");
	if (rfile == NULL) {
		return;
	}

	fclose(rfile);

	strcpy(newname, filename);
#ifdef WIN32
	GetLocalTime(&systime);
	sprintf(timeanddate, "-%04d.%02d.%02d-%02d.%02d.%02d",
		systime.wYear, systime.wMonth, systime.wDay, systime.wHour,
		systime.wMinute, systime.wSecond);
#else
	localtime_r(&timep, &systime);

	sprintf(timeanddate, "-%04d.%02d.%02d-%02d.%02d.%02d",
		systime.tm_year, systime.tm_mon, systime.tm_mday,
		systime.tm_hour, systime.tm_min, systime.tm_sec);
#endif

	if (strlen(newname) > 0) {
		pext = &newname[strlen(newname) - 1];
		while (*pext != '.' && pext > newname) {
			pext--;
		}

		if (*pext == '.') {
			strcpy(ext, pext);
			*pext = 0;
			strcat(newname, timeanddate);
			strcat(newname, ext);
		} else {
			strcat(newname, timeanddate);
		}
	}

	LDBGSTR2
	    ("misc_checkfilename : '%s' already exists, new filename is '%s'",
	     filename, newname);
	strcpy(filename, newname);
}
